import chalk from 'chalk';
import { highlightLine } from './formatter.js';

export function formatWithCollapse(lines) {
  let stackBuffer = [];
  let output = [];
  let inStack = false;

  for (const line of lines) {
    if (/^\s*at\s/.test(line)) {
      stackBuffer.push(line);
      inStack = true;
    } else {
      if (inStack && stackBuffer.length > 3) {
        output.push(chalk.gray(`[📦 Stack trace de ${stackBuffer.length} líneas colapsado]`));
      } else {
        output.push(...stackBuffer.map(l => chalk.dim(l)));
      }
      stackBuffer = [];
      inStack = false;
      output.push(highlightLine(line));
    }
  }

  if (stackBuffer.length) {
    if (stackBuffer.length > 3) {
      output.push(chalk.gray(`[📦 Stack trace de ${stackBuffer.length} líneas colapsado]`));
    } else {
      output.push(...stackBuffer.map(l => chalk.dim(l)));
    }
  }

  return output;
}
